\documentclass{article}

\usepackage{amsmath}
\usepackage{amssymb}
\usepackage{amsthm}
\usepackage{graphicx}
\usepackage{hyperref}
\usepackage{subcaption}
\usepackage{float}
\usepackage{tikz}
\usetikzlibrary{decorations.pathreplacing,positioning,calc,intersections,3d,shapes.geometric,math}%,external}
%\tikzexternalize[prefix=tikz/]
\usepackage{colortbl}
\usepackage{algorithm,algpseudocode}

\newcommand{\dxdy}[2]{\frac{d #1}{d #2}}
\newcommand{\dxdyk}[3]{\frac{d^{#3} #1}{d {#2}^{#3}}}
\newcommand{\pdxdy}[2]{\frac{\partial #1}{\partial #2}}
\newcommand{\liminfty}[1]{\lim_{#1 \to \infty}}
\newcommand{\limab}[2]{\lim_{#1 \to #2}}

\newcommand{\abs}[1]{\left \vert #1 \right \vert}
\newcommand{\norm}[1]{\left \Vert #1 \right \Vert}
\newcommand{\order}[1]{\mathcal{O} \left ( #1 \right )}
\newcommand{\set}[1]{\left \{ #1 \right \}}
\newcommand{\Set}[2]{\left \{ #1 \ \middle \vert \ #2 \right \}}
\newcommand{\vmat}[1]{\begin{vmatrix} #1 \end{vmatrix}}
\DeclareMathOperator{\sign}{sign}
\DeclareMathOperator{\diag}{diag}

\newcommand{\bbn}{\mathbb{N}}
\newcommand{\bbz}{\mathbb{Z}}
\newcommand{\bbq}{\mathbb{Q}}
\newcommand{\bbr}{\mathbb{R}}
\newcommand{\bbc}{\mathbb{C}}
\newcommand{\bbf}{\mathbb{F}}

\newtheorem{conj}{Conjecture}
\newtheorem{theorem}{Theorem}
\newtheorem{lemma}[theorem]{Lemma}
\newtheorem{corollary}[theorem]{Corollary}
\newtheorem{proposition}[theorem]{Proposition}
\newtheorem{definition}{Definition}
%\newtheorem{algorithm}{Algorithm}

\definecolor{darkgreen}{rgb}{0,0.6,0.1}

\let\vec\mathbf

\title{Adjacent combinations in the combinatorial number system}
\author{Conor McCoid}

\begin{document}

\maketitle

\begin{abstract}
In this article I define the notion of adjacent combinations, find the adjacency matrix for these combinations and present algorithms for their use.
\end{abstract}

\section{Introduction}
\label{sec: intro}

% to do:
%	write the algorithms needed and test them
%		research Pascal's triangle algorithms

There exist problems in mathematics where one must consider objects or properties related to combinations of numbers.
To each combination one must assign a value or a Boolean or some other identifying feature that must be stored and processed.
In some of these problems one then examines the same objects or properties of the union or intersection of two combinations.

The example I have in mind is the intersection of two simplices in a general dimension.
Over the course of an algorithm set to calculate such an intersection one must find the intersection between the various $m$--faces of the two simplices.
These $m$--faces are described by the unique combination of vertices that enclose them.

Without going too deep into the details on simplicial intersections, note that to each intersection of an $m$--face one can assign a sign value to it based on which side of a dividing hyperplane it lies.
Two intersections of opposing sign indicate an intersection of an $(m+1)$--face.
The two intersections arise from two separate $m$--faces which share all but one vertex of the parent simplex, and the $(m+1)$--face has all vertices of the two $m$--faces.

This motivates the following two questions:
What is the most efficient method for identifying which combinations differ by exactly one number, and;
Having found two such combinations, how does one find their union or intersection?

We consider first the most elementary of methods.
Suppose we store the binary representation of the combinations $J$ and $K$ in vectors $\vec{J}$ and $\vec{K}$, each of length $n$.
That is, for the combination $J$ the $i$--th entry of $\vec{J}$ is 1 if $i \in J$ and 0 otherwise.
The number of elements by which they differ is then $\vec{J} \oplus \vec{K},$ where $\oplus$ represents the `exclusive or' operator.
The union of $J$ and $K$ is then represented by $\vec{J} \vee \vec{K}.$
Both operations, which may be combined, take $n$ comparisons of bits.

The problem with this approach is largely to do with storage.
When one needs to store properties of several combinations with varying lengths, one needs a sparse vector of length $2^n$.
Retrieving this information may prove expensive computationally.
Moreover, this procedure must be done for each pair of $J$ and $K$, the number of which may increase superlinearly with $m$. %nb: are there results for this?

Suppose instead for each combination we store the list of numbers.
Let us consider the combinations $J = \set{j_1, j_2, \dots, j_m}$ and $K = \set{k_1, k_2, \dots, k_m}$.
Suppose also that we have stored them in lexicographical order, such that $j_1 < j_2 < \dots < j_m$.
One may then test how many are equal using the following algorithm.
\begin{algorithm}
Inputs: $J,K$
\caption{$K \setminus J$}
\begin{algorithmic}[1]
\State $f(J,K)$
\If{$J = \emptyset$}
	\State $S = K$
\ElsIf{$K = \emptyset$}
	\State $S = \emptyset$
\ElsIf{$j_1 = k_1$}
	\State $S = f(J \setminus \set{j_1}, K \setminus \set{k_1})$
\ElsIf{$j_1 < k_1$}
	\State $S = f(J \setminus \set{j_1}, K)$
\Else
	\State $S = f(J, K \setminus \set{k_1})$
	\State $S = S \cup \set{k_1}$
\EndIf
\State \Return $S$
\end{algorithmic}
\end{algorithm}

For our example problem, the two combinations have the necessary property if the length of $S$ is 1.
This takes $m$ evaluations of $\sign(j_1-k_1)$ to determine.
One can then find the union using $J \cup K = J \cup S$.
The algorithm can be halted by adding a conditional break after line 12, stopping the procedure if it is ever found that $S$ contains two elements.

Each test of two combinations is one subtraction and a check of a trinary-valued function.
As before this must be done for each pair of $J$ and $K$, which may again be numerous.
Here the storage becomes even more complicated, with each collection of $m$--combinations using sparse tensors of size $n^m$.
Alternatively, one can store vectors of length equal to the number of $m$--combinations and an indicator matrix with the same number of rows and $m$ columns with entries equal to the elements of the combinations.

Based on the issues described an ideal approach satisfies two criteria.
Firstly, it does not need to connect every pair of combinations to determine which ones differ by exactly one element.
This would save all computations but that of the union of two combinations.
Secondly, it provides integer representations of each combination to optimize storage and retrieval of any information stored on each combination.
Integer representations would enable efficient use of sparse vectors and matrices, or reduce the use of indicator matrices to indicator vectors.

\section{The combinatorial number system}
\label{sec: combo}

The second criterion identified at the end of the last section, asking for integer representations of each combination, gives a clear goal in our search for an efficient algorithm.
The combinations need to be enumerated in some sense.
To do so one can use the combinatorial number system, attributed to Lehmer \cite{lehmer1964machine} and revisited by Knuth \cite{knuth2011art}.
This number system is also known as combinadics \cite{mccaffrey2004generating} or the Macaulay representation of an integer \cite{green1989restrictions}, deriving from \cite{macaulay1927some}.

\begin{definition}[Combinadics]
The ranking $N(J)$ of a subset $J=\set{c_1,\dots,c_m}$, arranged in lexicographical order, of natural numbers $\set{0,\dots,n-1}$ is equal to
\begin{equation*}
N(J) = \binom{c_m}{m} + \dots + \binom{c_1}{1}.
\end{equation*}
\end{definition}

To each combination of $m$ natural numbers there is now a ranking.
That is, there is a bijection between the set of combinations of $m$ natural numbers chosen from $\set{0,\dots,n-1}$ and the set of natural numbers $\set{0,\dots,\binom{n}{m}-1}$.

Generating $N(J)$ from $J$, called ranking, requires calculation of the relevant binomial coefficients.
Given we know all elements of $J$ this requires $m$ binomial coefficients to be calculated and summed.
A ranking algorithm can be found in \cite{mccaffrey2004generating}.

Generating $J$ from $N(J)$, called unranking, can be achieved through a greedy algorithm using the same coefficients.
Let $c$ be the largest number in $\set{0,\dots,n-1}$ such that $N(J) \geq \binom{c}{m}$.
Then $c \in J$.
Subtract $\binom{c}{m}$ from $N(J)$ and repeat, now considering the numbers $\set{0,\dots,c-1}$ and the $(m-1)$--combination $J \setminus \set{c}$.
This requires as many binomial coefficients to be calculated and compared with a ranking as $n - \min J$.
An overview of unranking algorithms can be found in \cite{donnot2020unranking}.

\section{Adjacent combinations}
\label{sec: adj}

Recall the first criterion identified at the end of Section \ref{sec: intro}, namely that we determine which combinations differ by exactly one element without comparing each pair of combinations.
Let us define this property explicitly.

\begin{definition}[Adjacency]
Two combinations $J$ and $K$ with the same cardinality are said to be adjacent if they differ by one element.
That is,
$$|K \cap J| = |K|-1=|J|-1.$$
\end{definition}

Recall that adjacent combinations are the only ones for which we are motivated to find their union.
In the motivating problem these combinations represent intersections of $m$--faces which can give rise to intersections of an $(m+1)$--face.

We can consider each combination $J$ to be a node in a graph with one edge to each adjacent combination $K$.
This graph has an adjacency matrix $A^n_m$, where $m$ is the cardinality of $J$ and $K$ and $n$ is the number of elements chosen from.
The element at position $N(J),N(K)$ is 1 if $J$ and $K$ are adjacent, and therefore have an edge, and 0 otherwise.
Finding all adjacent $K$ then reduces to finding all rows for which the $N(J)$--th column has a 1.

The matrix $A^n_m$ is symmetric since the graph it represents is undirected.
That is, $J$ is adjacent to $K$ if and only if $K$ is adjacent to $J$.

Recall that the binomial coefficients are symmetric.
Namely, $\binom{n}{m} = \binom{n}{n-m}$.
Since these form the basis of the combinatorial number system, we expect them to impart some of this symmetry onto the structures that arise from it.
Indeed, we do find this symmetry reflected in the matrix $A^n_m$.
To explain it, we must introduce the concept of the anti-transpose of a matrix $A$.

\begin{definition}[Anti-transpose] \label{def: antitranspose}
The anti-transpose of a matrix $A$, denoted $A^\tau$, is its reflection over its northeast-to-southwest diagonal.
That is, if $A \in \bbr^{m \times m}$ then $\left ( A^\tau \right )_{i,j} = \left ( A \right )_{m-j+1, m-i+1}$, where $i,j=\set{1,\dots,m}$.
\end{definition}

\begin{lemma} \label{lem: anti-transpose}
\begin{equation}
(A_m^n)^\tau = A_{n-m}^n.
\end{equation}
Equivalently, by the definition of anti-transpose and given that $A_m^n \in \bbr^{\binom{n}{m} \times \binom{n}{m}}$,
\begin{equation*}
 (A_m^n)_{i,j} = (A_{n-m}^n)_{\binom{n}{m} - j+1, \binom{n}{m} - i + 1}.
\end{equation*}
\end{lemma}

\begin{proof}
The coordinates $i$ and $j$ index two combinations, $J_i$ and $J_j$, each with $m$ elements out of a possible $n$.
That is, $i = N(J_i)+1$ and $j=N(J_j)+1$.
Likewise, $\binom{n}{m} - i + 1 = N(K_i)+1$ and $\binom{n}{m}-j+1=N(K_j)+1$ where $K_i$ and $K_j$ have $n-m$ elements.
Then the combinations $K_i$ and $K_j$ can be represented by those $m$ elements not in $K_i$ and $K_j$, $K_i^\complement$ and $K_j^\complement$.
These sets have $m$ elements and so their adjacency graph is a linear transformation of $A_m^n$.
Thus, there exists a linear transform between $A_m^n$ and $A_{n-m}^n$.

To prove this linear transformation is indeed the anti-transpose it suffices to prove $K_i^\complement = J_i$ and $K_j^\complement = J_j$,
which may be done by showing that $N(J^\complement) + 1 = \binom{n}{m} - (N(J)+1) + 1$, or $N(J^\complement) + N(J) = \binom{n}{m} - 1$ for all $J$.

This is proven by induction over $m$.
Starting with the base case $m=1$ we have that $J = \set{c_1}$ and $J^\complement = \set{0,\dots,n-1} \setminus \set{c_1}$, leading to
\begin{align*}
N(J^\complement) + N(J) = & \binom{c_1}{1} + \sum_{k=0}^{c_1-1} \binom{k}{k+1} + \sum_{k=c_1+1}^n \binom{k}{k} \\
 = & c_1 + 0 + n-(c_1+1) \\
 = & n-1 \\
 = & \binom{n}{1} - 1.
\end{align*}
The statement is then true for $m=1$.

Suppose the statement is true for $m$.
We then verify the statement for $m+1$.
Let $J=\set{c_k}_{k=1}^{m+1}$ and $J^\complement = \set{\hat{c}_k}_{k=1}^{n-m-1}$, then
\begin{align*}
N(J^\complement) + N(J) = & \sum_{k=1}^{m+1} \binom{c_k}{k} + \sum_{j=1}^{n-m-1} \binom{\hat{c}_j}{j} \\
= & \binom{c_{m+1}}{m+1} + \sum_{k=1}^m \binom{c_k}{k} + \sum_{\hat{c}_j < c_{m+1}} \binom{\hat{c_j}}{j} + \binom{c_{m+1}}{j_0} + \sum_{\hat{c}_j > c_{m+1}} \binom{\hat{c}_j}{j+1} \\
    & + \sum_{\hat{c}_j > c_{m+1}} \binom{\hat{c}_j}{j} - \sum_{\hat{c}_j > c_{m+1}} \binom{\hat{c}_j}{j+1} - \binom{c_{m+1}}{j_0} \\
= & \binom{n}{m} - 1 + \binom{c_{m+1}}{m+1} + \sum_{j=j_0}^{n-m-1} \binom{\hat{c}_j}{j} - \sum_{j=j_0}^{n-m-1} \binom{\hat{c}_j}{j+1} - \binom{c_{m+1}}{j_0}.
\end{align*}
Note that $j_0$ is the index of the first element of $J^\complement$ that is larger than $c_{m+1}$.
In fact, since every element of $\set{0, \dots, n-1}$ is found either in $J$ or $J^\complement$, $\hat{c}_{j_0} = c_{m+1} + 1$.
Moreover, $\hat{c}_{j} = c_{m+1} + j - j_0 + 1$ for all $j > j_0$.
In particular, $\hat{c}_{n-m-1} = c_{m+1} + n-m-j_0 = n-1$, as long as $c_{m+1} \neq n-1$.
Therefore, $c_{m+1} = m+j_0-1$ and $\hat{c}_j = m + j$ for all $j>j_0$.
This gives
\begin{align*}
N(J^\complement) + N(J) = & \binom{n}{m} - 1 & + & \binom{m+j_0 - 1}{m+1} + \sum_{j=j_0}^{n-m-1} \binom{m+j}{j} \\
	    & 			    &  - & \sum_{j=j_0}^{n-m-1} \binom{m+j}{j+1} - \binom{m+j_0-1}{j_0} \\
	= & \binom{n}{m} - 1 & + & \binom{m+j_0 - 1}{m+1} + \sum_{j=j_0}^{n-m-1} \binom{m+j}{j}- \sum_{j=j_0-1}^{n-m-1} \binom{m+j}{j+1} \\
	= & \binom{n}{m} - 1 & + & \binom{m+j_0 - 1}{m+1} + \sum_{j=j_0}^{n-m-1} \binom{m+j}{j} - \sum_{j=j_0}^{n-m} \binom{m+j-1}{j} \\
	= & \binom{n}{m} - 1 & + & \binom{m+j_0 - 1}{m+1} + \sum_{j=0}^{n-m-1} \binom{m+j}{j} - \sum_{j=0}^{j_0-1} \binom{m+j}{j} \\
	    &			&  -  & \sum_{j=0}^{n-m} \binom{m+j-1}{j} + \sum_{j=0}^{j_0-1}  \binom{m+j-1}{j}.
\end{align*}
\begin{figure}
	\centering
	\begin{tikzpicture}[
	addnode/.style={circle, fill=cyan},
	sumnode/.style={diamond, fill=pink}]
		\node (1ch1) {1}; % error in naming: off by one in both indices
		\node[addnode] (2ch1) [below left of=1ch1] {1};
		\node (2ch2) [below right of =1ch1] {1};
		\node (3ch1) [below left of=2ch1] {1};
		\node[addnode] (3ch2) [below right of=2ch1] {2};
		\node (3ch3) [below right of=2ch2] {1};
		\node (4ch1) [below left of=3ch1] {1};
		\node (4ch2) [below right of=3ch1] {3};
		\node[addnode] (4ch3) [below left of=3ch3] {3};
		\node (4ch4) [below right of=3ch3] {1};
		\node (5ch1) [below left of=4ch1] {1};
		\node (5ch2) [below right of=4ch1] {4};
		\node[sumnode] (5ch3) [below right of=4ch2] {6};
		\node (5ch4) [below left of=4ch4] {4};
		\node (5ch5) [below right of=4ch4] {1};
	\end{tikzpicture}
	\caption{The hockey-stick identity found in Pascal's triangle.
	For this example, $r=1$ and $k=4$.}
	\label{simplices fig: hockey-stick}
\end{figure}
To simplify the sums we make use of the hockey-stick identity, see Figure \ref{simplices fig: hockey-stick}:
\begin{equation*}
\sum_{j=0}^{k-r-1} \binom{r + j}{j} = \binom{k}{r+1}.
\end{equation*}
In the four sums we use $r=m$ or $r=m-1$, and $k=n$ or $k=j_0+r$.
We are then left with
\begin{align*}
N(J^\complement) + N(J) = & \binom{n}{m} - 1 + \binom{m+j_0 - 1}{m+1} + \binom{n}{m+1} - \binom{m+j_0}{m+1} \\
	    & 			 - \binom{n}{m} + \binom{m+j_0-1}{m} \\
	= & \binom{n}{m+1} - 1 + \binom{m+j_0 - 1}{m+1} + \binom{m+j_0-1}{m} - \binom{m+j_0}{m+1} \\
	= & \binom{n}{m+1} - 1,
\end{align*}
where we use Pascal's rule to eliminate the terms with $j_0$.

For the special case where $c_{m+1} = n-1$, the summations reduce to
\begin{align*}
N(J^\complement) + N(J) = & \binom{n}{m} + \binom{n-1}{m+1} - \binom{n-1}{m-1} -1 \\
	= & \binom{n-1}{m} + \binom{n-1}{m+1} -1\\
	= & \binom{n}{m+1}-1,
\end{align*}
making use of Pascal's rule twice.
\end{proof}

As a corollary, $A^{2m}_m$ is bisymmetric.

If one is constructing all matrices $A^n_m$ for a particular value of $n$ then one need only do so for $m \leq n/2$.
For larger $m$, it suffices to use $(A^n_{n-m})^\tau$.

For $m=1$ there is only one element in each combination.
Therefore, all combinations are adjacent and the graph is a simplex.
The adjacency matrix is $A^n_1 = 1_{n \times n} - I$.

Next, consider $m=2$.
For $A_2^3$ one can use Lemma \ref{lem: anti-transpose} to prove $A_2^3 = A_1^3$, whose form is known.
For $A_2^4$, we note it is bisymmetric by the same lemma.
Thus, the only part missing is the upper right block, which must be persymmetric.
We construct the matrix element by element.
\begin{table}
\centering
\begin{tabular}{c | c  c  c}
 & (0,3) & (1,3) & (2,3) \\ \hline
 (0,1) & 1 & 1 & 0 \\
 (0,2) & 1 & 0 & 1 \\
 (1,2) & 0 & 1 & 1
 \end{tabular}
 \caption{Upper right block of the matrix $A_2^4$.}
 \label{tab: A24}
\end{table}
The result may be found in Table \ref{tab: A24}.
For the remaining adjacency matrices, we must find a recurrence relation.

\begin{lemma} \label{lem: recurrence}
For $n > m > 1$
\begin{equation}
A_m^n = \begin{bmatrix} A^{n-1}_m & \tilde{A}_m^n \\ (\tilde{A}_m^n)^\top & A_{m-1}^{n-1} \end{bmatrix}, \quad \tilde{A}_m^n = \begin{bmatrix} \tilde{A}_m^{n-1} & 0_{\binom{n-2}{m-2} \times \binom{n-2}{m}} \\ I_{\binom{n-2}{m-1}} & \tilde{A}_{m-1}^{n-1} \end{bmatrix},
\end{equation}
with starting conditions
\begin{equation}
A_1^n = \begin{bmatrix} 0 & 1 & \dots & 1 \\ 1 & 0 & \ddots & \vdots \\ \vdots & \ddots & \ddots & 1 \\ 1 & \dots & 1 & 0 \end{bmatrix}, \quad \tilde{A}_1^n = \begin{bmatrix} 1 \\ \vdots \\ 1 \end{bmatrix}, \quad \tilde{A}_2^4 = \begin{bmatrix} 1 & 1 & 0 \\ 1 & 0 & 1 \\ 0 & 1 & 1 \end{bmatrix} .
\end{equation}
\end{lemma}

\begin{proof}
We divide the proof into two parts:
first, we prove the diagonal blocks of $A_m^n$;
second, we prove the structure of $\tilde{A}_m^n$.
Since $A_m^n$ is symmetric, the lower left block is the transpose of the upper right block.

Let $N(J_i)+1$ be the index of a column for the left blocks of $A_m^n$, and $N(J_j)+1$ the same for the right blocks.
Let $N(K_i)+1$ be the index of a row for the upper blocks of $A_m^n$, and $N(K_j)+1$ the same for the lower blocks.
Then $J_i$ and $K_i$ are $m$--combinations that do not contain the index $n-1$, while $J_j$ and $K_j$ do.
Then $N(J_i)+1$ and $N(K_i)+1$ are also indices for the matrix $A_m^{n-1}$.
The relationship between $J_i$ and $K_i$ has not changed, and so
\begin{equation*}
\left ( A_m^{n-1} \right )_{N(J_i)+1,N(K_i)+1} = \left ( A_m^n \right )_{N(J_i)+1,N(K_i)+1}.
\end{equation*}
\begin{table}
\centering
\begin{tabular}{r | c c}
	& $J_i$ & $J_j$ \\ \hline
	$K_i$ & $A^{n-1}_m$ & $\tilde{A}^n_m$ \\
	$K_j$ & $(\tilde{A}^n_m)^\tau$ & $A^{n-1}_{m-1}$
\end{tabular}
\caption{Correspondance between combinations and blocks of $A^n_m$.}
\end{table}

Note that 
\begin{align*}
N(J_j) = & \binom{n-1}{m} + \binom{c_{m-1}}{m} + \dots + \binom{c_1}{1} \\
	= & \binom{n-1}{m} + N(J_j \setminus \set{n-1}), \\
N(K_j) = & \binom{n-1}{m} + N(K_j \setminus \set{n-1}).
\end{align*}
Thus, the sets $J_j$ and $K_j$ have the same relation as $J_j \setminus \set{n-1}$ and $K_j \setminus \set{n-1}$, with their indices shifted by $\binom{n-1}{m}$.
The lower right block of $A_m^n$ is then the matrix $A_{m-1}^{n-1}$.

For the second part of the proof we define the combinations $\tilde{J}_i$, $\tilde{J}_j$, $\tilde{K}_i$ and $\tilde{K}_j$ to subdivide the combinations $J_i$ and $K_j$, respectively, and to represent the blocks of $\tilde{A}_m^n$.
Let $N(\tilde{J}_i)+1$ be the index of a column for the left blocks of $\tilde{A}_m^n$, $N(\tilde{J}_j)+1$ the same for the right blocks, $N(\tilde{K}_i)+1$ for the upper blocks and $N(\tilde{K}_j)+1$ for the lower blocks.
Then $n-1 \in \tilde{J}_i, \tilde{J}_j$, $n-1 \notin \tilde{K}_i, \tilde{K}_j$, $n-2 \in \tilde{J}_j, \tilde{K}_j$ and $n-2 \notin \tilde{J}_i, \tilde{K}_i$.
%\begin{align*}
%n-1 \in & \tilde{J}_i, & n-2 \notin & \tilde{J}_i, \\
%n-1, n-2 \in & \tilde{J}_j, \\
%& & n-1, n-2 \notin & \tilde{K}_i, \\
%n-2 \in & \tilde{K}_j, & n-1 \notin & \tilde{K}_j .
%\end{align*}
\begin{table}
\centering
\begin{tabular}{r | c c}
	& $n-1 \notin$ & $n-1 \in$ \\ \hline
	$n-2 \notin$ & $\tilde{K}_i$ & $\tilde{J}_i$ \\
	$n-2 \in$ & $\tilde{K}_j$ & $\tilde{J}_j$
\end{tabular}
\caption{Summary of known differences between the combinations $\tilde{J}_i$, $\tilde{J}_j$, $\tilde{K}_i$ and $\tilde{K}_j$.}
\label{tab: tilde}
\end{table}
Since $\tilde{K}_i$ contains neither $n-2$ nor $n-1$ and $\tilde{J}_j$ contains both, there are no adjacent sets in this block.
This block is then a zero matrix of size $\binom{n-2}{m} \times \binom{n-2}{m-2}$.
The number of rows corresponds to the number of possible $\tilde{K}_i$, and the number of columns to the number of possible $\tilde{J}_j$.

The sets $\tilde{J}_i$ and $\tilde{K}_j$ differ by at least one element, since the former has $n-1$ and not $n-2$ and the latter $n-2$ and not $n-1$.
Thus, the two sets are adjacent if and only if $\tilde{J}_i \setminus \set{n-1} = \tilde{K}_j \setminus \set{n-2}$, and therefore $N(\tilde{J}_i \setminus \set{n-1}) = N(\tilde{K}_j \setminus \set{n-2})$.
The lower left block of $\tilde{A}_m^n$ is then the identity matrix with $\binom{n-2}{m-1}$ rows and columns, the number of possible values of $N(\tilde{J}_i \setminus \set{n-1})$.

For the upper left block, consider a new set $J_k = \tilde{J}_i \setminus \set{n-1} \cup \set{n-2}$.
Then $\tilde{J}_i$ is adjacent to $\tilde{K}_i$ if and only if $J_k$ is adjacent to $\tilde{K}_i$, since $\tilde{K}_i$ contains neither $n-2$ nor $n-1$.
Thus, $$\left ( A_m^n \right )_{N(\tilde{J}_i)+1,N(\tilde{K}_i)+1} = \left ( A_m^{n-1} \right )_{N(J_k)+1,N(\tilde{K}_i)+1}.$$
The pair $N(J_k)$, $N(\tilde{K}_i)$ index an element in the block $\tilde{A}_m^{n-1}$, and so
the upper left block of $\tilde{A}_m^n$ is a copy of $\tilde{A}_m^{n-1}$.

Since both $\tilde{J}_j$ and $\tilde{K}_j$ contain $n-2$, these two sets are adjacent if and only if $\tilde{J}_j \setminus \set{n-1}$ and $\tilde{K}_j \setminus \set{n-2}$ are adjacent.
Neither of these $(m-1)$--combinations contain $n-1$, the former contains $n-2$ and the latter does not.
These combinations therefore index an element in $A_{m-1}^{n-1}$, specifically in the block $\tilde{A}_{m-1}^{n-1}$.
Since $N(\tilde{J}_j) = \binom{n-1}{m} + N(\tilde{J}_j \setminus \set{n-1})$ and $N(\tilde{K}_j) = \binom{n-2}{m} + N(\tilde{K}_j \setminus \set{n-2})$, the element of the $(m-1)$--combinations is shifted by $\binom{n-1}{m}$ columns and $\binom{n-2}{m}$ rows to become the element of the $m$--combinations.
Thus the lower right block of $\tilde{A}_m^n$ is the block $\tilde{A}_{m-1}^{n-1}$.
\end{proof}

Note that for the special case of $A_m^{2m}$, which is bisymmetric by Lemma \ref{lem: anti-transpose}, the matrix has the form
\begin{align*}
A_m^{2m} = & \begin{bmatrix} A_m^{2m-1} & \tilde{A}_m^{2m} \\ (\tilde{A}_m^{2m})^\top & (A_m^{2m-1})^\tau \end{bmatrix}, & \tilde{A}_m^{2m} = & \begin{bmatrix} \tilde{A}_m^{2m-1} & 0_{\binom{2m-2}{m-2} \times \binom{2m-2}{m}} \\ I_{\binom{2m-2}{m-1}} & (\tilde{A}_m^{2m-1})^\tau \end{bmatrix} \\
	= & \begin{bmatrix} (A^{2m-1}_{m-1})^\tau & \tilde{A}_m^{2m} \\ (\tilde{A}_m^{2m})^\top & A_{m-1}^{2m-1} \end{bmatrix} & = & \begin{bmatrix} (\tilde{A}_{m-1}^{2m-1})^\tau & 0_{\binom{2m-2}{m} \times \binom{2m-2}{m}} \\ I_{\binom{2m-2}{m-1}} & \tilde{A}_{m-1}^{2m-1} \end{bmatrix}.
\end{align*}

We may now construct the matrix $A^n_m$ with the following algorithm.
\begin{algorithm}
\caption{Construct $A^n_m$}
\begin{algorithmic}[1]
\State construct $A^n_1$, which contains all $A^k_1$ for $k \leq n$
\State $A^n_{n-1} = A^n_1$
\State construct $A^4_2$ from known blocks $A^3_2$ and $\tilde{A}^4_2$
\For{$k=5$ to $n$}
	\State construct $\tilde{A}^k_2$ and use it to construct $A^k_2$
\EndFor
\State $A^n_{n-2} = (A^n_2)^\tau$
\State $m=3$
\While{$m < n/2$}
	\State set $A^{2m-1}_m = (A^{2m-1}_{m-1})^\tau$
	\State construct $\tilde{A}^{2m}_m$ and $A^{2m}_m$
	\For{$k=2m+1$ to $n$}
		\State construct $\tilde{A}^k_m$ and $A^k_m$
	\EndFor
	\State $A^n_{n-m} = (A^n_m)^\tau$
	\State $m=m+1$
\EndWhile
\State \Return $A^n_m$ for all $m$
\end{algorithmic}
\end{algorithm}

\section{Unions of adjacent combinations}

Based on the previous section we can now determine which combinations are adjacent to one another without calculations.
The most costly part of using the combinatorial number system is then the calculation of $N(J \cup K)$ for two adjacent combinations $J$ and $K$.
We seek to reduce this cost by finding a formula for $N(J \cup K)$ based on $N(J)$ and $N(K)$.

Let us suppose this formula can be expressed as a matrix $B^n_m$ in the same way the adjacency of $J$ and $K$ were expressed by $A^n_m$.
Specifically,
\begin{equation*}
\left ( B^n_m \right )_{N(J) + 1, N(K)+1} = \begin{cases} N(J \cup K)+1 & J,K \text{ adjacent} \\ 0 & \text{otherwise} \end{cases}
\end{equation*}
Naturally, $B^n_m$ has non-zero entries only at the non-zero entries of $A^n_m$.
It is also symmetric, as $N(J \cup K) = N(K \cup J)$.

\begin{lemma}
\begin{align*}
B^n_1 = & \begin{bmatrix} 0 & 1 & 2 & \dots & \binom{n}{2}+1 \\
							& 0 & 3 & \dots & \binom{n}{2}+2 \\
							&    & \ddots & \dots & \vdots \\
							&	&	&	0	&	\binom{n}{2}+n \\
							&	&	&		&	0 \end{bmatrix}, &
B^n_{n-1} = & A^n_1.
\end{align*}
\end{lemma}

\begin{proof}
The matrix $B^n_1$ represents the unions of two combinations of one element each.
The result is then a combination of two elements.
Suppose $J=\set{j}$ and $K=\set{k}$ are the two combinations, and without loss of generality $j>k$.
Then $j=N(J)+1$, $k=N(K)+1$ and 
\begin{align*}
N(J \cup K) = & \binom{j}{2} + \binom{k}{1} \\
		= & \binom{N(J)}{2} + N(K) \\
\implies (B^n_1)_{j,k} =(B^n_1)_{k,j} = & k + \binom{j-1}{2}.
\end{align*}

The elements of $B^n_{n-1}$ represent the union of combinations of $n-1$ elements chosen from $n$ possible elements.
Thus, any two of these combinations are adjacent and their union contains all $n$ elements.
The ranking of the complete set of $n$ elements is 0, and so the entries of $B^n_{n-1}$ are all 1 except along the diagonal where they are 0, as no combination is adjacent to itself.
\end{proof}

This provides starting values for the $B^n_m$.
We now seek a recursive form for these matrices, similar to $A^n_m$, see Lemma \ref{lem: recurrence}.

\begin{lemma}
\begin{align*}
B^n_m = & \begin{bmatrix} B^{n-1}_m & \tilde{B}^n_m \\ ( \tilde{B}^n_m )^\top & B^{n-1}_{m-1} \end{bmatrix} + \binom{n-1}{m+1} \begin{bmatrix} 0 & \tilde{A}^n_m \\ 0 & A^{n-1}_{m-1} \end{bmatrix}, \\
\tilde{B}^n_m = & \begin{bmatrix} \tilde{B}^{n-1}_m & 0 \\ \diag(K) & \tilde{B}^{n-1}_{m-1} \end{bmatrix} - \binom{n-2}{m+1} \begin{bmatrix} \tilde{A}^{n-1}_m & 0 \\ 0 & 0 \end{bmatrix},
\end{align*}
where $\diag(K)$ is the diagonal matrix with entries equal to the row index.
\end{lemma}

\begin{proof}
As before, consider the combinations $J_i$ and $K_i$ which do not contain the number $n-1$ and the combinations $J_j$ and $K_j$ which do.
By the same logic from the proof of Lemma \ref{lem: recurrence} the value of $N(J_i \cup K_i)$ is found in $B^{n-1}_m$.
Also as noted there
\begin{align*}
N(J_j) = & \binom{n-1}{m} + N(J_j \setminus \set{n-1}), \\
N(K_j) = & \binom{n-1}{m} + N(K_j \setminus \set{n-1}),
\end{align*}
and so $$N(J_j \cup K_j) = \binom{n-1}{m+1} + N( (J_j \setminus \set{n-1}) \cup (K_j \setminus \set{n-1})),$$
which is $\binom{n-1}{m+1}$ added to a value from $B^{n-1}_{m-1}$.
In fact, since $J_j$ contains $n-1$ all non-zero entries in the right blocks of $B^n_m$ will have $\binom{n-1}{m+1}$ added to them.
Thus, $B^n_m$ may be written as
\begin{equation*}
B^n_m = \begin{bmatrix} B^{n-1}_m & \tilde{B}^n_m \\ (\tilde{B}^n_m)^\top & B^{n-1}_{m-1} \end{bmatrix} + \binom{n-1}{m+1} \begin{bmatrix} 0 & \tilde{A}^n_m \\ 0 & A^{n-1}_{m-1} \end{bmatrix},
\end{equation*}
where $\tilde{B}^n_m$ contains the values of $N(J_j \cup K_i)$.

To find the form of $\tilde{B}^n_m$ consider the combinations $\tilde{J}_i$, $\tilde{J}_j$, $\tilde{K}_i$ and $\tilde{K}_j$ from the proof of Lemma \ref{lem: recurrence}, summarized in Table \ref{tab: tilde}.
The combinations $\tilde{J}_j$ and $\tilde{K}_i$ were found to not be adjacent and so their union need not be considered here.

Let us proceed by considering the combinations $\tilde{J}_i$ and $\tilde{K}_i$.
Neither contain $n-2$, and so we may consider a third combination $J_k = \tilde{J}_i \setminus \set{n-1} \cup \set{n-2}$.
Then
\begin{align*}
N(J_k \cup \tilde{K}_i) = 		& \binom{n-2}{m+1} + N( (J_k \setminus \set{n-2}) \cup \tilde{K}_i ), \\
N(\tilde{J}_i \cup \tilde{K}_i) = & \binom{n-1}{m+1} + N( (\tilde{J}_i \setminus \set{n-1}) \cup \tilde{K}_i ) \\
			= 				& \binom{n-1}{m+1} + N( J_k \setminus \set{n-2}) \cup \tilde{K}_i ) \\
			=				& \binom{n-1}{m+1} - \binom{n-2}{m+1} + N(J_k \cup \tilde{K}_i).
\end{align*}
Thus, this element of $\tilde{B}^n_m$ is an element of $\tilde{B}^{n-1}_{m}$ with $\binom{n-2}{m+1}$ removed.

Now consider $\tilde{J}_j$ and $\tilde{K}_j$.
Since $\tilde{J}_j$ contains $n-1$ and both contain $n-2$ we can write
\begin{align*}
N(\tilde{J}_j \cup \tilde{K}_j) = & \binom{n-1}{m+1} + N( ( \tilde{J}_j \setminus \set{n-1} ) \cup \tilde{K}_j ) \\
			= 				& \binom{n-1}{m+1} + N( (\tilde{J}_j \setminus \set{n-1} ) \cup ( \tilde{K}_j \setminus \set{n-2} ))
\end{align*}
and so this is an element of $\tilde{B}^{n-1}_{m-1}$ with an additional $\binom{n-1}{m+1}$.

Finally, we consider $\tilde{J}_i$ and $\tilde{K}_j$.
We suppose they are adjacent elements, meaning they lie on the diagonal of this block.
The two elements by which these sets differ is $n-1$ and $n-2$.
The rest remains the same.
That is, 
\begin{align*}
\tilde{J}_i \cap \tilde{K}_j = & \tilde{K}_j \setminus \set{n-1} \setminus \set{n-2}, \\
\tilde{J}_i \cup \tilde{K}_j = & \tilde{K}_j \cup \set{n-1}, \\
\implies N(\tilde{J}_i \cup \tilde{K}_j) = & N(\tilde{K}_j) + \binom{n-1}{m+1}.
\end{align*}
This provides the final block of $\tilde{B}^n_m$.
\end{proof}

Based on the form of $B^n_m$ presented in the previous lemma, it is necessary to compute all previous such matrices to arrive at the values of $N(J \cup K)$.
Since for the applications discussed herein do not require all such values, this is likely even more expensive than before.
However, it does suggest a recursive algorithm which may produce some efficiency improvements, see Algorithm \ref{alg: B}.

\begin{algorithm}
\caption{Recursive calculation of $N(J \cup K)$}
\label{alg: B}
\begin{algorithmic}[1]
\State $[x,X]=\texttt{CombSum}(N(J),N(K),K,n,m)$
\State assume $N(J) > N(K)$ and $J$ is adjacent to $K$
\If{$N(J) \leq m$} % B^{m+1}_m
	\State \Return $x = 0$, $X = \set{0, \dots, m}$
\ElsIf{$m=1$} % B^n_1
	\State \Return $x = N(K) + \binom{N(J)}{2}$, $X = K \cup \set{N(J)-1}$
\Else
	\State $a = \binom{n-1}{m}$
	\If{$a > N(J)$} % n-1 is not in J
		\State \Return $[x,X] = \texttt{CombSum}(N(J),N(K),K,n-1,m)$
	\Else
		\If{$a \leq N(K)$} % n-1 is in K
			\State $[x,X] = \texttt{CombSum}(N(J)-a,N(K)-a,K \setminus \set{n-1},n-1,m-1)$
		\Else
			\State $c=\binom{n-1}{m-1}$, $d=\binom{n-2}{m}$
			\If{$c > N(J)-a$} % n-2 is not in J
				\If{$d \leq N(K)$} % n-2 is in K
					\State $x = N(K)$, $X = K$
				\Else % n-2 is not in K
					\State $[x,X] = \texttt{CombSum}(N(J)-a+d,N(K),K,n-1,m)$
					\State $x = x - \binom{n-2}{m+1}$, $X = X \setminus \set{n-2}$
				\EndIf
			\Else % n-2 is in J
				\State $[x, X] = \texttt{CombSum}(N(J)-a,N(K)-d,K \setminus \set{n-2},n-1,m-1)$
			\EndIf
		\EndIf
		\State \Return $x = x + \binom{n-1}{m+1}$, $X = X \cup \set{n-1}$
	\EndIf
\EndIf
\end{algorithmic}
\end{algorithm}

Most cases of the algorithm recursively call the algorithm with smaller inputs, then adding to the value of $N(J \cup K)$.
It builds on established values of $N(J)$ found in $B^n_{n-1}$ and $B^n_1$, and the lower left blocks of $\tilde{B}^n_m$.

Since the algorithm is building up $N(J \cup K)$ from known values, constructing $J \cup K$ from known $K$ can be done at the same time.
This is more efficient than a standard greedy algorithm as much of the work has already taken place to find $N(J \cup K)$.

Through any procedure to compute $N(J \cup K)$ it is probable that one will need most, if not all, values of $\binom{j}{m}$ for $j=m-1$ to $n$, for $m=1$ to $n$.
These are the values of Pascal's triangle up to the $n$--th row.
This gives roughly $n^2/4$ unique entries, due to symmetry.
Any method to find $N(J \cup K)$ will then likely benefit from an efficient algorithm for the computation and storage of Pascal's triangle.
The examples in this article use Matlab's built-in \texttt{pascal()}.

It is tempting to use the anti-transpose of $B^n_m$ in the same way we do for $A^n_m$, see Lemma \ref{lem: anti-transpose}, to halve the computation time.
However, the anti-transpose of $B^n_m$ does not correspond to $B^n_{n-m}$.

\begin{corollary}
Let $J$ and $K$ be two adjacent $m$--combinations, then
$$\left ( B^n_m \right )^\tau_{N(J)+1,N(K)+1} = \binom{n}{m} - N(J \cap K) .$$
\end{corollary}

\begin{proof}
We know that $N(J)+N(J^\complement) = \binom{n}{m} - 1$ by the proof of Lemma \ref{lem: anti-transpose} and so
\begin{align*}
\left ( B^n_m \right)^\tau_{N(J)+1,N(K)+1} = & \left ( B^n_m \right)_{\binom{n}{m} - N(K), \binom{n}{m} - N(J)}, \quad \text{see Definition \ref{def: antitranspose}} \\
	= & \left ( B^n_m \right)_{N(K^\complement)+1, N(J^\complement) + 1} \\
	= & N(K^\complement \cup J^\complement)+1 \\
	= & N( (J \cap K)^\complement )+1 \\
	= & \binom{n}{m} - N(J \cap K).
\end{align*}
This concludes the proof.
\end{proof}

Therefore, the anti-transpose of $B^n_m$ provides the values of $N(J \cap K)$.
Algorithm \ref{alg: B} can then be used to find these values with minor manipulation, if these are useful for some application.

\section{Numerical comparisons}

%===new commands===%
\newcommand{\SimpGraph}[4]{
	\foreach \x in {1,...,#1} {
		\coordinate (#3\x) at ($#2 + (90-\x*360/#1+180/#1:#4)$);
		\filldraw[black] (#3\x) circle (1pt);}
	\foreach \x in {1,...,#1} {
		\foreach \y in {\x,...,#1} {
			\draw[thick,black] (#3\x) -- (#3\y);}}
	}

\newcommand{\SimpGraphEmpty}[3]{
	\foreach \x in {1,...,#1} {
		\coordinate (#3\x) at ($#2 + (90-\x*360/#1+180/#1:1)$);}
	}
\newcommand{\SimpCoords}{
	\SimpGraphEmpty{3}{(0,0-2)}{S} \SimpGraphEmpty{3}{(3,0-2.5)}{T} \SimpGraphEmpty{3}{(1.5,2-2.5)}{U}
	\path (S3)--(T3) coordinate[midway] (023);
	\path (U3)--(T3) coordinate[near start] (123); % needs shifting?
	\path (S1)--(T1) coordinate[midway] (024);
	\path (U1)--(U3) coordinate[midway] (134);
	
	\path (S1)--(U1) coordinate[near end] (014); % needs shifting?
	\path (S2)--(U2) coordinate[very near end] (015);
	\path (S2)--(T2) coordinate[midway] (025);
	\path (U3)--(U2) coordinate[near end] (135);
	}
%==end new commands===%

To properly compare the various methods for computing properties related to combinations, let us consider a single example problem for which these methods become useful.
We will consider the intersection of two 6-simplices, simplices in $\bbr^5$.
Each has 6 vertices.
To make the discussion straightforward we will consider only the intersection of one simplex with 5 successive hyperplanes.

Take the first of these hyperplanes and slice it through the simplex.
Each vertex of the simplex has an index associated with it, from 0 to 5.
The hyperplane divides these indices into two groups, one for the positive side of the hyperplane and the other for the negative.
These indices form our first set of combinations, each containing a single element.
Each is then adjacent to all the others, and there are then as many new combinations as there are pairs of positive and negative indices.
This totals nine intersections, forming the 3-3 duoprism, see Figure \ref{fig: simplex}.
\begin{figure}
\centering
	\begin{tikzpicture}
		\matrix[row sep=1em, column sep=1em,every cell/.style={scale=0.7}]{
			\SimpGraph{6}{(0,-2)}{S}{2} 
			\foreach \x in {0,1,...,5} {\node at ($(0,-2)+(60-\x*60:2.2)$) {\x};}
			\coordinate (T1) at (0.25,-4); \coordinate (T2) at (0.25,0); \draw[very thick,red] (T1) -- (T2); 
			\foreach \x in {1,2,3} {\foreach \y in {4,5,6} {\filldraw[blue] (intersection of S\x--{S\y} and T1--T2) circle (3pt);}}
			&
			\SimpGraph{3}{(0,0-2)}{0}{1} \SimpGraph{3}{(3,0-2.5)}{2}{1} \SimpGraph{3}{(1.5,2-2.5)}{1}{1}
			\foreach \x in {1,2,3} {\foreach \y in {0,1} {\foreach \z in {1,2} {\draw[thick,blue] (\y\x) -- (\z\x);}}}
			\foreach \x in {0,1,2} {\foreach \y[count=\i from 3] in {3,1,2} {\node[above] at (\x\y) {\x\i};}}
			\\};
	\end{tikzpicture}
	\caption{Intersection of the 5-simplex with a hyperplane.}
	\label{fig: simplex}
\end{figure}

\begin{figure}
\centering
	\begin{tikzpicture}
		\matrix[row sep=0em, column sep=1em, every cell/.style={scale=0.7}]{
		% S=0, T=2, U=1, 1->4, 2->5, 3->3
			\SimpCoords
			\foreach \x in {1,2,3} {\draw[black] (S\x) -- (U\x);}
			\foreach \x in {S,U} {\draw[black] (\x1) -- (\x2) -- (\x3) -- cycle;}
			\filldraw[blue,opacity=0.3] (134) node[above,black,opacity=1] {134} --(135) node[left,black,opacity=1] {135} --(015) node[below,black,opacity=1] {015} --(014) node[right,black,opacity=1] {014} --cycle;
			&
			\SimpCoords
			\foreach \x in {1,3} {\draw[black] (S\x)-- (T\x)-- (U\x)-- cycle;}
			\foreach \x in {S,T,U} {\draw[black] (\x1)--(\x3);}
			\filldraw[blue,opacity=0.3] (134) node[above,black,opacity=1] {134} --(123) node[left,black,opacity=1] {123} --(023) node[below left,black,opacity=1] {023} --(024) node[below right,black,opacity=1] {024} --(014) node[right,black,opacity=1] {014} --cycle;
			&
			\SimpCoords
			\foreach \x in {1,2,3} {\draw[black] (U\x)--(T\x);}
			\foreach \x in {U,T} {\draw[black] (\x1)--(\x2)--(\x3)--cycle;}
			\filldraw[blue,opacity=0.3] (134) node[above,black,opacity=1] {134} --(135) node[below,black,opacity=1] {135} --(123) node[left,black,opacity=1] {123} --cycle;
			\\
			\SimpCoords
			\foreach \x in {1,2} {\draw[black] (S\x)--(T\x)--(U\x)--cycle;}
			\foreach \x in {S,T,U} {\draw[black] (\x1)--(\x2);}
			\filldraw[blue,opacity=0.3] (015) node[left,black,opacity=1] {015} --(025) node[below,black,opacity=1] {025} --(024) node[right,black,opacity=1] {024} --(014) node[above,black,opacity=1] {014} --cycle;
			&
			\SimpCoords
			\foreach \x in {1,2,3} {\draw[black] (S\x)--(T\x);}
			\foreach \x in {S,T} {\draw[black] (\x1)--(\x2)--(\x3)--cycle;}
			\filldraw[blue,opacity=0.3] (023) node[left,black,opacity=1] {023} --(024) node[above right,black,opacity=1] {024} --(025) node[below,black,opacity=1] {025} --cycle;
			&
			\SimpCoords
			\foreach \x in {3,2} {\draw[black] (S\x)--(T\x)--(U\x)--cycle;}
			\foreach \x in {S,T,U} {\draw[black] (\x3)--(\x2);}
			\filldraw[blue,opacity=0.3] (023) node[left,black,opacity=1] {023} --(025) node[below,black,opacity=1] {025} --(015) node[above right,black,opacity=1] {015} --(135) node[above right,black,opacity=1] {135} --(123) node[left,black,opacity=1] {123} --cycle;
		\\};
	\end{tikzpicture}
	\caption{Intersection of the 5-simplex and two hyperplanes. Each 3D object is a projection of the 3-3 duoprism with a blue plane indicating how the second hyperplane divides its vertices. The resulting section is the 3-4 scutoid \cite{gomez2018scutoids}.}
	\label{fig: duoprism}
\end{figure}
The resulting combinations are again divided by a second hyperplane.
Adjacency is now no longer universal and the number of new combinations depends on both adjacency and positive/negative pairs.
Due to the high dimensionality of the duoprism we consider six of its projections.
The hyperplane has its own projections on each of these, see Figure \ref{fig: duoprism}.
Each represents a face of the resulting section, the 3-4 scutoid \cite{gomez2018scutoids}.

\begin{figure}
\centering
	\begin{tikzpicture}
		\matrix[row sep=1em, column sep=1em]{
			\coordinate (123) at (0,0);
			\coordinate (023) at (0,-1);
			\coordinate (134) at (-0.5,0.5);
			\coordinate (135) at (0.5,0.5);
			\coordinate (015) at (1,-0.5);
			\coordinate (014) at (-1,-0.5);
			\coordinate (025) at (0.75,-1.5);
			\coordinate (024) at (-0.75,-1.5);
			
			\draw (123) -- (023) -- coordinate[midway] (0234) (024) -- (014) -- (134) -- coordinate[midway] (1234) cycle;
			\draw (123) -- (135) -- coordinate[near end] (0135) (015) -- coordinate[midway] (0125) (025) -- (023);
			\draw (135) -- coordinate[near start] (1345) (134);
			\draw (014) -- (015);
			\draw (024) -- coordinate[near end] (0245) (025);
			
			\filldraw[blue,opacity=0.3] (1345) node[above,black,opacity=1] {1345} -- (0135) node[above right,black,opacity=1] {0135} -- (0125) node[right,black,opacity=1] {0125} -- (0245) node[below,black,opacity=1] {0245} -- (0234) node[left,black,opacity=1] {0234} -- (1234) node[left,black,opacity=1] {1234} -- cycle;
			&
			\SimpGraphEmpty{6}{(0,-0.5)}{S}
			\draw (S1) \foreach \x in {2,3,...,6} {-- (S\x)} -- cycle;
			\path (S2) -- (S3) coordinate[midway] (01245);
			\path (S4) -- (S5) coordinate[midway] (01345);
			\draw[thick,blue] (01245) node[right,black] {01245} -- (01345) node[left,black] {01345};
			&
			\draw (0,0.5) -- (0,-1.5) coordinate[midway] (012345);
			\filldraw[blue] (012345) circle (1pt);
			\node[below right] (012345) {012345};
		\\};
	\end{tikzpicture}
	\caption{Remaining sections of the 5-simplex with secitoning hyerplanes shown in blue. These sections are, in order, the 3-4 scutoid \cite{gomez2018scutoids}, the hexagon, and the line, the sections of which are the hexagon, the line and the point.}
	\label{fig: sections}
\end{figure}
There are three more sectioning hyperplanes to consider.
The three resulting sections are shown in Figure \ref{fig: sections}.
These sections are the hexagon, the line and the point.

\begin{figure}
\centering
	\begin{tikzpicture}[
	plusnode/.style={circle, fill=cyan},
	minnode/.style={diamond, fill=pink}]
		\foreach \x in {2,1,0} {\node[plusnode] at (0,2.5-\x) (\x) {\x};}
		\foreach \x in {3,4,5} {\node[minnode] at (0,2.5-\x) (\x) {\x};}
		
		\foreach \x[count=\i from 0] in {03,04,05,13} {\node[plusnode] at (2,3.5-\i) (\x) {\x};}
		\foreach \x[count=\i from 0] in {14,15,23,24,25} {\node[minnode] at (2,-0.5-\i) (\x) {\x};}
		
		\foreach \x[count=\i from 0] in {023,024,123,134} {\node[plusnode] at (4,3.5-\i) (\x) {\x};}
		\foreach \x[count=\i from 0] in {014,015,025,135} {\node[minnode] at (4,-0.5-1.25*\i) (\x) {\x};}
		
		\foreach \x[count=\i from 0] in {0124,0134} {\node[plusnode] at (6,2.5-1.5*\i) (\x) {\x};}
		\foreach \x[count=\i from 0] in {0235,0245,1235,1345} {\node[minnode] at (6,-0.5-1.5*\i) (\x) {\x};}
		
		\node[plusnode] at (8,1) (01245) {01245};
		\node[minnode] at (8,-1) (01345) {01345};
		
		\foreach \x in {0,1,2} {\foreach \y in {3,4,5} {\draw[->,cyan,very thick] (\x) -- (\x\y);} }
		\foreach \x in {3,4,5} {\foreach \y in {0,1,2} {\draw[->,pink,very thick] (\x) -- (\y\x);} }
		
		\path[->,cyan,very thick] (03) edge (023)
			(04) edge (024) edge (014)
			(05) edge (015) edge (025)
			(13) edge (123) edge (134) edge (135)
			(023) edge (0235)
			(123) edge (1235)
			(024) edge (0124) edge (0245)
			(134) edge (0134) edge (1345)
			(0124) edge (01245)
			(0134) edge (01345);
		\path[->,pink,very thick] (14) edge (134) edge (014)
			(15) edge (015) edge (135)
			(23) edge (023) edge (123)
			(24) edge (024)
			(25) edge (025)
			(014) edge (0124) edge (0134)
			(025) edge (0235) edge (0245)
			(135) edge (1235) edge (1345)
			(0245) edge (01245)
			(1345) edge (01345);
	\end{tikzpicture}
	\caption{Network of combinations arising from example intersection.
		Each subsequent column represents a successive intersection with a hyperplane.
		Blue circles are on the positive side of the hyperplane, red diamonds on the negative.}
	\label{fig: network}
\end{figure}
All intersections are indexed by the vertices of the simplex that give rise to them.
They can be organized into two piles depending on which side of the dividing hyperplanes they lie.
This gives a sequence of combinations that can be arranged into a network, see Figure \ref{fig: network}.
Each of the three algorithms are used 100 times to run through this network and store properties related to each of the combinations.
\begin{table}
\centering
	\begin{tabular}{c | c c c}
	& Binary & Lexicographical & Combinadic \\
	& representation & ordering & ranking \\ \hline
	Time for 100 runs (s) & 0.164 & 0.362 & 0.190
	\end{tabular}
	\caption{Time in seconds for 100 runs of the example network of Figure \ref{fig: network}.}
\end{table}

% table of times for the artificial example
The lexicographical ordering is twice as slow as the other two methods tested.
The largest cost for this algorithm is the computation of $J \cup K$, which most likely has more efficient implementations possible.
However, another significant hurdle is that there is no built-in way to flag if the sign of a given combination has been found.
For the other two, both the binary representation and combinadic ranking provide an automatic way to index combinations.
Without this, the lexicographical algorithm recomputes the same combinations repeatedly, creating several needless copies and inflating computation time exponentially.

It is then useful to compare the binary representation and the combinadic ranking algorithms as a function of $n$, the dimension of the simplices.
To do this, we run the algorithms 100 times on random examples.
A random example can be established by running any of these algorithms once, generating random signs for specific combinations.

\begin{figure}
\centering
	\includegraphics[width=0.7\textwidth]{MTLB_Combinadics_Efficiency_v1_20220827.eps}
	\caption{Average computation time as a function of dimension of simplices. For comparison, the binary representation and combinadic ranking algorithms are presented, alongside the time to construct Pascal's triangle and the combinadic adjacency matrix.}
	\label{fig: eff n}
\end{figure}
The results, see Figure \ref{fig: eff n}, show that the combinadic algorithm increases in computational cost slower than the binary representation algorithm.
Both are comparable for smaller dimensions, while starting around $n=6$ the combinadic algorithm begins to be faster.
Also plotted is the average time for the start-up costs associated with the combinadic algorithm, specifically constructing the adjacency matrix and Pascal's triangle.
If one has an example problem for which many more combinations need to be considered, then these start-up costs need not be repeated and the combinadic algorithm becomes even more advantageous.

\section{Conclusions}

In this paper we considered three types of algorithms for enumerating properties of $m$--combinations:
binary representation;
lexicographical ordering of the combination, and;
combinadic ranking.

Binary representation requires significantly more storage than the others.
Each $m$--combination, for all values of $m$, has a place in any vector or matrix that stores information on them.
However, it has proven itself straightforward to implement and efficient for lower dimensions.

The lexicographical ordering does not provide any easy identification of the $m$--combinations.
One relies on the specific ordering in which they are created to identify them.
This causes problems when identifying which combinations have already been tested.

Combinadic ranking shows great promise as a solution to the storage problems of binary representation while maintaining efficiency in lower dimensions and improving on it in higher dimensions.
It is decidedly harder to implement but once done it provides a clear solution to the issues of the other two algorithms.

\bibliographystyle{siam}
\bibliography{references}

\end{document}